Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionSplit/FrmConstructionSplitAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionSplit/FrmConstructionSplitAuxiliary.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionSplit/FrmConstructionSplitAuxiliary.cs	(revision 51)
@@ -0,0 +1,914 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Collections;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    partial class FrmConstructionSplit
+    {
+        #region 部署コンボより担当者コードを取得する
+        /// <summary>
+        /// 部署コンボより担当者コードを取得する
+        /// </summary>
+        /// <returns></returns>
+        private int GetDepartmentCode()
+        {
+            try
+            {
+                // 表示されていない場合は選択無
+                //if (!cmbDepartment.Visible) return 0;
+
+                return CommonMotions.cnvInt(cmbDepartment.SelectedValue);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return 0;
+            }
+        }
+        #endregion
+
+        #region 担当者コンボより担当者コードを取得する
+        /// <summary>
+        /// 担当者コンボより担当者コードを取得する
+        /// </summary>
+        /// <returns></returns>
+        private int GetConstructionPersonCode()
+        {
+            try
+            {
+                // 表示されていない場合は選択無
+                //if (!cmbConstructionPerson.Visible) return 0;
+
+                return CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return 0;
+            }
+        }
+        #endregion
+
+        #region コンボボックス初期表示
+        /// <summary>
+        /// コンボボックス初期表示
+        /// </summary>
+        private void InitCombBox()
+        {
+            try
+            {
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    InitCombBox_OLD();
+                }
+                else
+                {
+                    InitCombBox_NEW();
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region コンボボックス初期表示（旧）
+        /// <summary>
+        /// コンボボックス初期表示（旧）
+        /// </summary>
+        private void InitCombBox_OLD()
+        {
+            try
+            {
+                // システム権限によってデータアクセスに制限がある
+                if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.AdminSecurityManagement
+                || CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.PresidentAuthority].Key
+                || CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SupervisorAuthority].Key
+                || CommonMotions.LoginUserData.DepartmentCode == CommonDefine.s_GeneralAffairsDevision)
+                {
+                    // システム管理者
+                    // 最高機密管理者
+                    // 統括機密管理者
+                    // 総務部所属者は全て見える
+
+                    // 部署・担当者コンボ表示
+                    DispAllCombBoxControl(true);
+                }
+                else if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SuperiorAuthority].Key)
+                {
+                    // 所属長
+                    // 部署コンボ非表示
+                    NonDispDepCombBox();
+                }
+                else if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key)
+                {
+                    // 一般使用者（自分のみアクセス可能）
+                    // 部署・担当者コンボ非表示
+                    DispAllCombBoxControl(false);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region コンボボックス初期表示（新）
+        /// <summary>
+        /// コンボボックス初期表示（新）
+        /// </summary>
+        private void InitCombBox_NEW()
+        {
+            try
+            {
+                int AllPath = (int)CommonDefine.SecurityRangePos.AllPath;           // 全部署
+                int Multiple = (int)CommonDefine.SecurityRangePos.Multiple;         // 複数部署
+                int Only = (int)CommonDefine.SecurityRangePos.Only;                 // 自部署のみ
+                int None = (int)CommonDefine.SecurityRangePos.None;                 // 自担当者のみ
+
+                if (CommonMotions.LoginUserData.PersonCode == CommonDefine.AdminCode
+                    || CommonMotions.LoginUserSecurity.SecRange == CommonDefine.SecurityRangeList[AllPath].Key)
+                {
+                    // 部署・担当者コンボ表示
+                    DispAllCombBoxControl(true);
+                }
+                else
+                {
+                    if (CommonMotions.LoginUserSecurity.SecRange == (int)CommonDefine.SecurityRangeList[Multiple].Key)
+                    {
+                        // 部署・担当者コンボ表示
+                        DispAllCombBoxControl(true);
+                    }
+                    else if (CommonMotions.LoginUserSecurity.SecRange == (int)CommonDefine.SecurityRangeList[Only].Key)
+                    {
+                        // 部署コンボ非表示
+                        NonDispDepCombBox();
+                    }
+                    else if (CommonMotions.LoginUserSecurity.SecRange == (int)CommonDefine.SecurityRangeList[None].Key)
+                    {
+                        // 部署・担当者コンボ表示
+                        DispAllCombBoxControl(false);
+                    }
+                }
+
+                // 総務業務使用者がログインしている場合はコンボを空白にする
+                if (CommonMotions.LoginUserSecurity.GeneralAffairs == (int)CommonDefine.GeneralAffairs.GeneralDep) return;
+
+                // 初期設定対象がコンボボックスデータにあればセットする
+                for (int i = 0; i < cmbDepartment.Items.Count; i++)
+                {
+                    KeyValuePair<int, string> wrkPair = (KeyValuePair<int, string>)cmbDepartment.Items[i];
+                    if (wrkPair.Key == CommonMotions.LoginUserData.DepartmentCode)
+                    {
+                        cmbDepartment.SelectedValue = CommonMotions.LoginUserData.DepartmentCode;
+                    }
+                }
+
+                for (int i = 0; i < cmbConstructionPerson.Items.Count; i++)
+                {
+                    KeyValuePair<int, string> wrkPair = (KeyValuePair<int, string>)cmbConstructionPerson.Items[i];
+                    if (wrkPair.Key == CommonMotions.LoginUserData.PersonCode)
+                    {
+                        cmbConstructionPerson.SelectedValue = CommonMotions.LoginUserData.PersonCode;
+                    }
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 部署コンボボックスの非表示処理
+        /// <summary>
+        /// 部署コンボボックスの非表示処理
+        /// </summary>
+        private void NonDispDepCombBox()
+        {
+            try
+            {
+                // 部署コンボ非表示
+                label12.Visible = false;
+                cmbDepartment.Visible = false;
+
+                // 表示位置のセット
+                Point loc13 = label13.Location;
+                loc13.X = label12.Location.X;
+                label13.Location = loc13;
+
+                Point loc4 = cmbConstructionPerson.Location;
+                loc4.X = label13.Location.X + label13.Width + 10;
+                cmbConstructionPerson.Location = loc4;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 全コンボボックス表示をON/OFFする
+        /// <summary>
+        /// 全コンボボックス表示をON/OFFする
+        /// </summary>
+        private void DispAllCombBoxControl(bool bDsp)
+        {
+            try
+            {
+                // 部署・担当者コンボ非表示
+                label12.Visible = bDsp;
+                cmbDepartment.Visible = bDsp;
+                label13.Visible = bDsp;
+                cmbConstructionPerson.Visible = bDsp;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 部署コンボボックスをセットする
+        /// <summary>
+        /// 部署コンボボックスへ文字をセットする
+        /// </summary>
+        private void SetcmbDepartment()
+        {
+            IOMDepartment depDB = new IOMDepartment();
+            bool bSave = m_bInitFlag;
+            m_bInitFlag = true;
+            try
+            {
+
+                cmbDepartment.DataSource = null;
+                cmbDepartment.Items.Clear();
+                cmbDepartment.Text = "";
+
+                string strSQL = string.Empty;
+                // 部署マスタを検索する
+                strSQL = "SELECT A.DEPARTMENTCODE, A.DEPARTMENTSTRING, A.DISPLAYORDER, COUNT(*)";
+                strSQL += " FROM DEPARTMENTMASTER A, PERSONINCHARGEMASTER B, CONSTRUCTIONBASEINFO C";
+                strSQL += " WHERE A.DELETEFLG = 0";
+
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    // システム権限によってデータアクセスに制限がある
+                    if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.SuperiorAuthority].Key
+                        || CommonMotions.LoginUserData.SecurityManagement == CommonDefine.SystemManageDiv[(int)CommonDefine.SysManaDivNo.UserAuthority].Key)
+                    {
+                        // 所属長
+                        // 一般使用者（自分のみアクセス可能）
+                        strSQL += string.Format(" AND A.DEPARTMENTCODE = {0}", CommonMotions.LoginUserData.DepartmentCode);
+                    }
+                }
+                else
+                {
+                    if (CommonMotions.LoginUserData.PersonCode == CommonDefine.AdminCode)
+                    {
+
+                    }
+                    else
+                    {
+                        // 参照部署マスタより取得する
+                        strSQL += " AND A.DEPARTMENTCODE IN (SELECT A1.DEPARTMENTCODE FROM PERSONDEPARTMENTMASTER A1";
+                        strSQL += string.Format(" WHERE A1.PERSONCODE = {0})", CommonMotions.LoginUserData.PersonCode);
+                    }
+                }
+                strSQL += " AND A.DEPARTMENTCODE = B.DEPARTMENTCODE";
+                strSQL += " AND B.PERSONCODE = C.CONSTRUCTIONPERSONCODE";
+                strSQL += " GROUP BY A.DEPARTMENTCODE, A.DEPARTMENTSTRING, A.DISPLAYORDER";
+                strSQL += " ORDER BY A.DISPLAYORDER ASC";
+
+                // 部署マスタ読込
+                ArrayList arList = new ArrayList();
+                if (!depDB.ExecuteReader(strSQL, ref arList)) return;
+
+                List<KeyValuePair<int, string>> ConstructionDataList = new List<KeyValuePair<int, string>>();
+                ConstructionDataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (object[] work in arList)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(CommonMotions.cnvInt(work[0])
+                                                                                    , CommonMotions.cnvString(work[1]));
+
+                    ConstructionDataList.Add(keyval);
+                }
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbDepartment, ConstructionDataList);
+
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    // 総務部所属者以外
+                    if (CommonMotions.LoginUserData.DepartmentCode != CommonDefine.s_GeneralAffairsDevision)
+                        cmbDepartment.SelectedValue = CommonMotions.LoginUserData.DepartmentCode;
+                }
+
+                return;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                depDB.close(); depDB = null;
+                m_bInitFlag = bSave;
+            }
+        }
+        #endregion
+
+        #region 担当者コンボボックスをセットする
+        /// <summary>
+        /// 担当者コンボボックスへ文字をセットする
+        /// </summary>
+        private void SetcmbPersons()
+        {
+            IOMPersonInCharge picDB = new IOMPersonInCharge();
+            List<PersonInChargeMaster> workList = new List<PersonInChargeMaster>();
+            bool bSave = m_bInitFlag;
+            m_bInitFlag = true;
+            try
+            {
+                cmbConstructionPerson.DataSource = null;
+                cmbConstructionPerson.Items.Clear();
+                cmbConstructionPerson.Text = "";
+
+                string strSQL = string.Empty;
+                int DepartmentCode = GetDepartmentCode();
+                if (DepartmentCode == 0)
+                    strSQL = " WHERE DELETEFLG = 0 ORDER BY EMPLOYEECLASSFLG ASC, DISPLAYORDER ASC";
+                else
+                    strSQL = string.Format(" WHERE DEPARTMENTCODE = {0} AND DELETEFLG = 0 ORDER BY EMPLOYEECLASSFLG ASC, DISPLAYORDER ASC", DepartmentCode);
+
+                // 担当者マスタ読込
+                if (!picDB.SelectAction(strSQL, ref workList)) return;
+
+                List<KeyValuePair<int, string>> ConstructionDataList = new List<KeyValuePair<int, string>>();
+                ConstructionDataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (PersonInChargeMaster work in workList)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(work.PersonCode, work.PersonName);
+
+                    ConstructionDataList.Add(keyval);
+                }
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbConstructionPerson, ConstructionDataList);
+
+                // 新セキュリティデータ対応済みかを確認する
+                if (CommonMotions.LoginUserData.SecCode == 0)
+                {
+                    // 一般ユーザーで総務部所属者ではない場合、ログイン者のコードをセットする
+                    if (CommonMotions.LoginUserData.DepartmentCode != CommonDefine.s_GeneralAffairsDevision)
+                    {
+                        cmbConstructionPerson.SelectedValue = CommonMotions.LoginUserData.PersonCode;
+                    }
+                }
+
+                return;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                picDB.close(); picDB = null;
+                m_bInitFlag = bSave;
+            }
+        }
+        #endregion
+
+        #region 担当者コンボボックスセット時部署をセットする
+        /// <summary>
+        /// 担当者コンボボックスセット時部署をセットする
+        /// </summary>
+        /// <returns></returns>
+        private bool SetPerosonToDepartment()
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            try
+            {
+                // コンボボックスより選択担当者を取得する
+                int PersonCode = GetConstructionPersonCode();
+                if (PersonCode < 1) return false;
+
+                int DepartmentCode = GetDepartmentCode();
+
+                string strSQL = PersonDB.CreatePrimarykeyString(PersonCode);
+                PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                PersonDB.SelectAction(strSQL, ref PersonRec);
+
+                // 部署コンボボックスへ部署コードセット
+                if (PersonRec.DepartmentCode > 0 && DepartmentCode != PersonRec.DepartmentCode)
+                {
+                    bool bSave = m_bInitFlag;
+                    m_bInitFlag = true;
+                    cmbDepartment.SelectedValue = PersonRec.DepartmentCode;
+                    SetcmbPersons();    // 担当者コンボボックス変更
+                    cmbConstructionPerson.SelectedValue = PersonCode;
+                    m_bInitFlag = bSave;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                PersonDB.close(); PersonDB = null;
+            }
+        }
+        #endregion
+
+        #region 初期営業期セット
+        /// <summary>
+        /// 初期営業期セット
+        /// </summary>
+        private void SetnumUD()
+        {
+            try
+            {
+                // 検索年度セット
+                // データにある事業期と現在の事業セット
+                int minval = 0;
+                int maxval = 0;
+                CommonMotions.GetPeriodYear(ref minval, ref maxval);
+                numUDConstPro.Minimum = minval;
+                numUDConstPro.Maximum = maxval;
+                numUDConstPro.Value = CommonMotions.SystemMasterData.BusinessPeriod;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region DB読込順
+        /// <summary>
+        /// DB読込順
+        /// </summary>
+        private enum ReadDBColumn
+        {
+            ConstructionCode = 0,
+            DetailString,
+            OrderersDivision,
+            OrderersCode,
+            OrderersName1,
+            OrderersName2,
+            ConstructionStatusFlg,
+        }
+        #endregion
+
+        #region 初期時データ取得
+        /// <summary>
+        /// 初期時データ取得
+        /// </summary>
+        private void InitDataLoad()
+        {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
+            try
+            {
+                dgvMaster.Rows.Clear();
+
+                int depCode = GetDepartmentCode();
+                int personCode = GetConstructionPersonCode();
+
+                string strSQL = string.Empty;
+                int StatusCode = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("非 受 注")).Key;
+
+                // ----- 工事結合の場合
+                // 対象全ての案件を検索する
+                strSQL = "SELECT DISTINCT A.CONSTRUCTIONCODE";
+                strSQL += ", B.DETAILSTRING";
+                strSQL += ", A.ORDERERSDIVISION";
+                strSQL += ", A.ORDERERSCODE";
+                strSQL += ", D.ORDERERSNAME1";
+                strSQL += ", D.ORDERERSNAME2";
+                strSQL += ", A.CONSTRUCTIONSTATUSFLG";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A, CONSTRUCTIONBASEINFODETAIL B, PERSONINCHARGEMASTER C, ORDERERSMASTER D";
+                strSQL += string.Format(" WHERE NOT EXISTS (SELECT * FROM PROCESSAPPROVAL APP WHERE APP.APPROVALCODE > {0} AND APP.APPROVALSTATUS = {1})",
+                                        (int)ClsExcute.ApprovalListNo.EstimateApproval,
+                                        //(int)ClsExcute.ApprovalListNo.PurchaseOrderEntryApproval,
+                                        (int)CommonDefine.ApprovalStatus.Approval);
+                strSQL += string.Format(" AND A.CONSTRUCTIONSTATUSFLG <> {0}", StatusCode);
+                strSQL += string.Format(" AND (A.CONSTRUCTIONPERIOD = {0})", numUDConstPro.Value);
+                strSQL += string.Format(" AND (A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE AND B.DETAILNO = {0})", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
+                strSQL += string.Format(" AND A.TYINGFLG != {0}", (int)CommonDefine.BaseInfoTyingFlg.Tying);
+                strSQL += string.Format(" AND A.JOINFLG = {0}", (int)CommonDefine.BaseInfoJoinFlg.Standard);
+                if (cmbConstructionPerson.Text.Length != 0)
+                {
+                    strSQL += string.Format(" AND (A.CONSTRUCTIONPERSONCODE = {0})", GetConstructionPersonCode());
+                }
+                else
+                {
+                    if (depCode != 0) strSQL += string.Format(" AND (C.DEPARTMENTCODE = {0})", depCode);
+                }
+
+                strSQL += " AND (C.PERSONCODE = A.SALESPERSONCODE";
+                strSQL += " Or C.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
+                strSQL += " Or C.PERSONCODE = A.CONSTRSUBPERSONCODE";
+                strSQL += " Or C.PERSONCODE = A.CONSTRUCTIONINSTRUCTOR)";
+                strSQL += " AND D.ORDERCOTEGORY = A.ORDERERSDIVISION AND D.ORDERERSCODE = A.ORDERERSCODE";
+                strSQL += " ORDER BY B.DETAILSTRING ASC, A.CONSTRUCTIONCODE DESC";
+
+                ArrayList BaseList = new ArrayList();
+                if (!BaseDB.ExecuteReader(strSQL, ref BaseList)) return;
+                if (BaseList.Count == 0) return;
+
+                // 要素表示
+                int i = 1;
+                string strStatus = string.Empty;
+                foreach (object[] wrk in BaseList)
+                {
+                    // データ表示
+                    int ConstructionCode = CommonMotions.cnvInt(wrk[(int)ReadDBColumn.ConstructionCode]);
+                    string EditConstructionCode = string.Format("{0}-{1:D2}", (ConstructionCode / 100), (ConstructionCode % 100));
+                    strStatus = CommonDefine.ProjectsStatus[CommonMotions.cnvInt(wrk[(int)ReadDBColumn.ConstructionStatusFlg])];
+                    dgvMaster.Rows.Add(i++,
+                                        EditConstructionCode,
+                                        CommonMotions.cnvString(wrk[(int)ReadDBColumn.DetailString]),
+                                        strStatus,
+                                        CommonMotions.cnvString(wrk[(int)ReadDBColumn.OrderersName1]) + " " + CommonMotions.cnvString(wrk[(int)ReadDBColumn.OrderersName2]),
+                                        CommonMotions.cnvInt(wrk[(int)ReadDBColumn.OrderersDivision]),
+                                        CommonMotions.cnvInt(wrk[(int)ReadDBColumn.OrderersCode]),
+                                        CommonMotions.cnvInt(wrk[(int)ReadDBColumn.ConstructionStatusFlg]));
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+                if (dgvMaster.RowCount < 9) dgvMaster.RowCount += (9 - dgvMaster.Rows.Count);
+
+            }
+        }
+        #endregion
+
+        #region 見積大項目表示
+        /// <summary>
+        /// 見積大項目表示
+        /// </summary>
+        private void ReadDatail()
+        {
+            IOEstimateData EstiDB = new IOEstimateData();
+            try
+            {
+                int ConstrCode = CommonMotions.cnvInt(m_SelectionCode);
+                string strSQL = "SELECT A.CONSTRUCTIONCODE, A.ITEMNAME, A.WORKNAME, A.PRICEVALUE, A.COMPONENTCODE FROM ESTIMATEDATA A";
+                strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", ConstrCode);
+                strSQL += " AND A.FIXEDITEMCODE = '0'";
+                ArrayList ArList = new ArrayList();
+
+                if (!EstiDB.ExecuteReader(strSQL, ref ArList)) return;
+
+                dgvSource.Rows.Clear();
+                int i = 1;
+                foreach (object[] objRec in ArList)
+                {
+                    dgvSource.Rows.Add(i++,
+                                        CommonMotions.cnvString(objRec[1]),
+                                        CommonMotions.cnvString(objRec[2]),
+                                        CommonMotions.cnvInt(objRec[3]).ToString("#,0"),
+                                        false,
+                                        CommonMotions.cnvInt(objRec[4])
+                                        );
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+            }
+            finally
+            {
+                EstiDB.close(); EstiDB = null;
+                if ((9 - dgvSource.RowCount) > 0) dgvSource.RowCount += (9 - dgvSource.RowCount);
+            }
+        }
+        #endregion
+
+        #region 新規分割作成
+        /// <summary>
+        /// 新分割合作成
+        /// </summary>
+        private void NewOrdererCreate()
+        {
+            FrmJoinSelect frm = new FrmJoinSelect();
+            try
+            {
+                // クリア
+                lblNewName.Text = string.Empty;
+                dgvSource.Rows.Clear();
+
+                // 選択された工事名を取得する
+                frm.NameList.Clear();
+
+                DataGridViewRow CurRow = dgvMaster.CurrentRow;
+                if (CurRow.Cells[(int)MasterGridColumn.ConstructionName].Value == null) return;
+
+                // 工事番号取得
+                string strConstrCode = CommonMotions.cnvString(dgvMaster.CurrentRow.Cells[(int)MasterGridColumn.ConstructionCode].Value).Replace("-", "");
+                m_SelectionCode = CommonMotions.cnvInt(strConstrCode);
+                // 工事名称取得
+                frm.NameList.Add(CommonMotions.cnvString(CurRow.Cells[(int)MasterGridColumn.ConstructionName].Value));
+
+                frm.OrderersDivision = CommonMotions.cnvInt(CurRow.Cells[(int)MasterGridColumn.OrderersDivision].Value);    // 発注者区分
+                frm.OrdererCode = CommonMotions.cnvInt(CurRow.Cells[(int)MasterGridColumn.OrderersCode].Value);             // 発注者番号
+                frm.ShowDialog();
+                if (frm.Result == DialogResult.Cancel) return;
+
+                lblNewName.Text = frm.ConstructionName;  // 新規工事名称
+
+                // 見積大項目表示
+                ReadDatail();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region 実行前チェック
+        /// <summary>
+        /// 実行前チェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DataCheck()
+        {
+            try
+            {
+                int SelCount = 0;
+                foreach (DataGridViewRow CurRow in dgvSource.Rows)
+                {
+                    // 選択されていないものは処理しない
+                    if (CurRow.Cells[(int)DetailGridColumn.SplitCheck].Value == null) continue;
+                    if (!(bool)CurRow.Cells[(int)DetailGridColumn.SplitCheck].Value) continue;
+
+                    SelCount++;
+                }
+                if (SelCount == 0)
+                {
+                    MessageBox.Show("データが選択されていません。", "選択エラー", MessageBoxButtons.OK);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 分割処理実行
+        /// <summary>
+        /// 分割処理実行
+        /// </summary>
+        private bool SplitData()
+        {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();		        // 工事基本情報
+            IOConstructionBaseInfoDetail BaseDDB = new IOConstructionBaseInfoDetail();  // 工事基本情報明細
+            IOEstimateData EstimateDB = new IOEstimateData();                           // 積算見積書データ
+            IOEstimateDataBody EstimateBDB = new IOEstimateDataBody();                  // 積算見積書ページデータ
+            IOEstimateDataDetail EstimateDDB = new IOEstimateDataDetail();              // 積算見積書明細データ
+
+            FrmNewOrContinueCopy frmCopy = new FrmNewOrContinueCopy();
+            bool bRet = false;
+            try
+            {
+                // 工事番号を作成する
+                m_ConstructionCode = CreateNewCode();
+                if (m_ConstructionCode == 0) return false;
+
+                BaseDB.connect(); BaseDDB.connect(); EstimateDB.connect(); EstimateBDB.connect(); EstimateDDB.connect();
+                BaseDB.beginTran(); BaseDDB.beginTran(); EstimateDB.beginTran(); EstimateBDB.beginTran(); EstimateDDB.beginTran();
+
+                // 工事基本情報・工事基本情報明細コピー
+                if(!frmCopy.RecordCopyTypeA(m_SelectionCode, m_ConstructionCode,BaseDB, BaseDDB))
+                {
+                    BaseDB.rollback(); BaseDDB.rollback();
+                    return false;
+                }
+                // 工事基本情報・工事基本情報明細
+                if (!CopyConstructionData(BaseDB, BaseDDB))
+                {
+                    BaseDB.rollback(); BaseDDB.rollback();
+                    return false;
+                }
+
+                // 積算見積書をコピーする
+                if(!frmCopy.RecordCopyTypeB(m_SelectionCode, m_ConstructionCode, EstimateDB, EstimateBDB, EstimateDDB))
+                {
+                    BaseDB.rollback(); BaseDDB.rollback(); EstimateDB.rollback(); EstimateBDB.rollback(); EstimateDDB.rollback();
+                    return false;
+                }
+
+                // 積算見積書データを整理する
+                if (!ArrangementAllEstimate(EstimateDB, EstimateBDB, EstimateDDB))
+                {
+                    BaseDB.rollback(); BaseDDB.rollback(); EstimateDB.rollback(); EstimateBDB.rollback(); EstimateDDB.rollback();
+                    return false;
+                }
+
+                BaseDB.commit(); BaseDDB.commit(); EstimateDB.commit(); EstimateBDB.commit(); EstimateDDB.commit();
+
+                bRet = true;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return false;
+            }
+            finally
+            {
+                if (!bRet)
+                {
+                    MessageBox.Show("分割処理に失敗しました。", "分割エラー", MessageBoxButtons.OK);
+                }
+
+                BaseDB.close(); BaseDDB.close(); EstimateDB.close(); EstimateBDB.close(); EstimateDDB.close();
+                BaseDB = null; BaseDDB = null; EstimateDB = null; EstimateBDB = null; EstimateDDB = null;
+                frmCopy.Dispose(); frmCopy = null;
+            }
+        }
+        #endregion
+
+        #region 新規工事番号作成
+        /// <summary>
+        /// 新規工事番号作成
+        /// </summary>
+        /// <returns></returns>
+        private int CreateNewCode()
+        {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
+            try
+            {
+                int PeriodValue = 0;
+                if (CommonMotions.SystemMasterData.ConstructionNoBase == (int)CommonDefine.SystemConstructionNoBase.BusinessPeriod)
+                {   // ----- 営業期ベースの時
+                    // 期数をセット
+                    PeriodValue = CommonMotions.SystemMasterData.BusinessPeriod;
+                }
+                else
+                {   // ----- 営業年度ベースの時
+
+                    // 営業年をセット
+                    PeriodValue = CommonMotions.SystemMasterData.ConstructionYear;
+                }
+                // 工事番号を作成する
+                return BaseDB.CreateNewCounstructionCode(PeriodValue);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return 0;
+            }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+            }
+        }
+        #endregion
+
+        #region 工事情報・工事情報明細作成
+        /// <summary>
+        /// 工事情報・工事情報明細作成
+        /// </summary>
+        /// <returns></returns>
+        private bool CopyConstructionData(IOConstructionBaseInfo BaseDB,
+                                        IOConstructionBaseInfoDetail DetailDB)
+        {
+            try
+            {
+                // ----- 工事情報
+                // 施工状態フラグ変更
+                int iCode = CommonDefine.ProjectsStatus.First(x => x.Value.Equals("依頼受け中")).Key;
+                if (!BaseDB.UpdateFeild(m_ConstructionCode, (int)IOConstructionBaseInfo.TableColumn.ConstructionStatusFlg
+                                        , iCode, false)) return false;
+                // 増減フラグOFF
+                if (!BaseDB.UpdateFeild(m_ConstructionCode, (int)IOConstructionBaseInfo.TableColumn.TyingFlg
+                                        , (int)CommonDefine.BaseInfoTyingFlg.Standard, false)) return false;
+                // 結合フラグOFF
+                if (!BaseDB.UpdateFeild(m_ConstructionCode, (int)IOConstructionBaseInfo.TableColumn.JoinFlg
+                                        , (int)CommonDefine.BaseInfoJoinFlg.Standard, false)) return false;
+
+                // ----- 工事情報明細
+                // 名前変更
+                if (!DetailDB.UpdateFeild(m_ConstructionCode, (int)IOConstructionBaseInfoDetail.TableColumn.DETAIL_STRING
+                                            , lblNewName.Text, false, (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 積算見積書データより不要データを削除する
+        /// <summary>
+        /// 積算見積書データより不要データを削除する
+        /// </summary>
+        /// <returns></returns>
+        private bool ArrangementAllEstimate(IOEstimateData EstimateDB,
+                                            IOEstimateDataBody EstimateBDB,
+                                            IOEstimateDataDetail EstimateDDB)
+        {
+            try
+            {
+                // バックアップを取る
+                string strSQL = "INSERT INTO BK_ESTIMATEDATA SELECT SYSDATE, A.* FROM ESTIMATEDATA A";
+                strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_SelectionCode);
+                if (!EstimateDB.ExecuteNonQuery(strSQL, false)) return false;
+
+                strSQL = strSQL.Replace("ESTIMATEDATA", "ESTIMATEDATABODY");
+                if (!EstimateBDB.ExecuteNonQuery(strSQL, false)) return false;
+
+                strSQL = strSQL.Replace("ESTIMATEDATABODY", "ESTIMATEDATADETAIL");
+                if (!EstimateDDB.ExecuteNonQuery(strSQL, false)) return false;
+
+                // 不要なデータを削除する
+                string strDelSource = string.Format(" WHERE CONSTRUCTIONCODE = {0} AND COMPONENTCODE > 0 AND (", m_SelectionCode);
+                string strDelDest = string.Format(" WHERE CONSTRUCTIONCODE = {0} AND COMPONENTCODE > 0 AND (", m_ConstructionCode);
+
+                bool bFirst = true;
+                int ComponentCode = 0;
+                foreach (DataGridViewRow CurRow in dgvSource.Rows)
+                {
+                    // 選択されたデータを探す
+                    if (CurRow.Cells[(int)DetailGridColumn.SplitCheck].Value == null) continue;
+                    if ((bool)CurRow.Cells[(int)DetailGridColumn.SplitCheck].Value == false) continue;
+
+                    ComponentCode = CommonMotions.cnvInt(CurRow.Cells[(int)DetailGridColumn.CompomentCode].Value);
+                    if(!bFirst)
+                    {
+                        strDelSource += " OR ";
+                        strDelDest += " AND ";
+                    }
+                    strDelSource += string.Format("COMPONENTCODE = {0}", ComponentCode);
+                    strDelDest += string.Format("COMPONENTCODE != {0}", ComponentCode);
+
+                    bFirst = false;
+                }
+                strDelSource += ")";
+                strDelDest += ")";
+
+                if (!EstimateDB.DeleteAction(strDelSource, false)) return false;
+                if (!EstimateDB.DeleteAction(strDelDest, false)) return false;
+
+                if (!EstimateBDB.DeleteAction(strDelSource, false)) return false;
+                if (!EstimateBDB.DeleteAction(strDelDest, false)) return false;
+
+                if (!EstimateDDB.DeleteAction(strDelSource, false)) return false;
+                if (!EstimateDDB.DeleteAction(strDelDest, false)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}", ex.Message);
+                return false;
+            }
+        }
+        #endregion
+    }
+}
